=== debian/changelog ===
cataclysm-dda (0.D-4build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 22 Mar 2020 16:35:43 +0100

cataclysm-dda (0.D-4) unstable; urgency=medium

  * Disable flaky crafting_test.

 -- Reiner Herrmann <reiner@reiner-h.de>  Thu, 15 Aug 2019 18:59:43 +0200

cataclysm-dda (0.D-3) unstable; urgency=medium

  * Upload to unstable.
  * Revert "Point to experimental branch in Vcs-Git".
  * Update website URLs in upstream files.
  * Update upstream metadata.
  * Bump Standards-Version to 4.4.0; no changes required.
  * Depend on debhelper-compat 12.
  * Install binaries from d/tmp so that dh_missing recognizes them.
  * Split upstream install target into -bin and -data targets.
  * Speed up arch:all-only builds by splitting d/rules targets into -arch
    and -indep targets.

 -- Reiner Herrmann <reiner@reiner-h.de>  Fri, 12 Jul 2019 22:06:24 +0200

cataclysm-dda (0.D-2) experimental; urgency=medium

  * Fix build with gcc9. (Closes: #925648)
  * Point to experimental branch in Vcs-Git.

 -- Reiner Herrmann <reiner@reiner-h.de>  Sat, 06 Apr 2019 13:40:03 +0200

cataclysm-dda (0.D-1) experimental; urgency=medium

  * New upstream release.
  * Update homepage.
  * Drop patches applied upstream.

 -- Reiner Herrmann <reiner@reiner-h.de>  Tue, 12 Mar 2019 19:38:29 +0100
