=== debian/rules ===
#!/usr/bin/make -f

#DH_VERBOSE = 1

include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

SDL_FLAGS = TILES=1 SOUND=1
CURSES_FLAGS =
COMMON_FLAGS = VERSION=$(DEB_VERSION_UPSTREAM) PREFIX=/usr ASTYLE=0 RELEASE=1 USE_XDG_DIR=1 LUA=1 LUA_BINARY=lua5.3 LANGUAGES=all DEBUG_SYMBOLS=1

# for building with ccache
#COMMON_FLAGS += CCACHE=1

%:
	dh $@

override_dh_auto_build-arch:
	dh_auto_build -- $(COMMON_FLAGS) $(CURSES_FLAGS)
	dh_auto_build -- $(COMMON_FLAGS) $(SDL_FLAGS)
	# generate icons
	for size in 16 32 64 128; do \
		mkdir -p debian/icons/hicolor/$${size}x$${size}/apps; \
		rsvg-convert -o debian/icons/hicolor/$${size}x$${size}/apps/cataclysm-dda.png -w $${size} data/xdg/cataclysm-dda.svg ; \
	done

override_dh_auto_build-indep:

override_dh_auto_install-arch:
	$(MAKE) install-bin DESTDIR=debian/tmp $(COMMON_FLAGS) $(CURSES_FLAGS)
	$(MAKE) install-bin DESTDIR=debian/tmp $(COMMON_FLAGS) $(SDL_FLAGS)

override_dh_auto_install-indep:
	$(MAKE) install-data DESTDIR=debian/tmp $(COMMON_FLAGS) $(SDL_FLAGS)

override_dh_auto_test-arch:
	# we need to pass build flags, otherwise some files are regenerated
	# and the binaries are relinked.
	LC_ALL=C.UTF-8 XDG_CONFIG_HOME=. dh_auto_test -- $(COMMON_FLAGS)

override_dh_auto_test-indep:

override_dh_install:
	dh_install -Xfont/ -Xcataicon.ico -XLICENSE.txt -Xchangelog.txt

override_dh_clean:
	$(MAKE) clean distclean
	dh_clean

override_dh_installchangelogs:
	dh_installchangelogs data/changelog.txt
